;*****************************************************************************
;*                            EINFACHER KEYER                                *
;*                              04.12.12                                     *
;*---------------------------------------------------------------------------*
;*                           BEGINN: 01.11.13                                *
;*                           ENDE  : XX.11.13                                *
;*                         GETESTET: XX.11.13                                *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "KEYER"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT &_WDT_OFF & _PWRTE_OFF  & _BODEN_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

 

MERK                    EQU     0X22               
MERK1                   EQU     0X23
CW                      EQU     0X24            
TXT_ZAE                 EQU     0X25
ANZ                     EQU     0X26
STRPKT                  EQU     0X27
;FR STRPKT GILT:
;BIT7 BEI 1 -STRICH MERKER BEI NORMALEM PADDEL-BETRIEB
;BIT0 BEI 1 -PUNKT MERKER BEI NORMALEM PADDEL-BETRIEB
;--
;BIT2 BEI 1 -IST SPEICHERENDE ERREICHT MIT 0X7A
;BIT4 BEI 1 -IST MERKER FR FESTTEXT-MORSEN GLEICH NACH DEM START
;BIT5 BEI 1 -IST MERKER WENN STRICH GEDRCKT IST GEHT ES ZUM BAKEN MORSEN BER
;BIT6 BEI 1 -IST ES PADDLE MORSEN / BEI 0 IST ES FESTTEXTMORSEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AD_L                    EQU     0X28
AD_H                    EQU     0X29
ZAE                     EQU     0X2A
ZAE1                    EQU     0X2B

SP_BYTE                 EQU     0X2C
ADR                     EQU     0X2D
ZAEHLER                 EQU     0X2E
ADR_MERK                EQU     0X2F
MERK2                   EQU     0X30
ZAEHLER1                EQU     0X31
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------

;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

GP0         EQU 0
GP1         EQU 1 
GP2         EQU 2 
GP3         EQU 3 
GP4         EQU 4
GP5         EQU 5 


;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ; SOFORT INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'00111000'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP0 + GP1 DIGITAL I/O     AN3 -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11111100'                 ;GP0 + GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL

;INIT TIMER 0 FUER 10MSEC FUER ZEITSCHLEIFE 
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)
                        MOVLW   B'10000111'                 ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0


;INIT TIMER 1 
                        MOVLW   B'00100000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [10]1:4 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10001100' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN3, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;DIE LED SOLL AM ANFANG AUS SEIN              
                        CLRF   GPIO
;---------------INITIALISIERUNG--ZU--ENDE-----------------------


                    MOVLW   D'100'         ;ZEITSCHLEIFE FUER 2SEC EINGESTELLT
                    CALL    ZS20MSEC       ;UM EINSCHALTIMPULS ZU UNTERDRUECKEN

                    CLRF    STRPKT

ANFANG              BSF     STRPKT, BIT6    ;SETZEN FR DAS PADDLE MORSEN
                    BCF     STRPKT, BIT4

                    BTFSS   GPIO, GP2       ;STRICH GEDRCKT?
                    CALL    STRICH          ;WENN JA STRICH MORSEN

                    BTFSS   GPIO, GP3       ;PUNKT GEDRCKT?
                    CALL    PUNKT           ;WENN JA PUNKT MORSEN

                    BTFSC   STRPKT, BIT7    ;WENN STRICH MERKER GESETZT
                    CALL    STRICH          ;STRICH MORSEN

                    BTFSC   STRPKT, BIT0    ;WENN PUNKT MERKER GESETZT
                    CALL    PUNKT           ;PUNKT MORSEN

;-------------

ABFRAGE             BTFSS   GPIO, GP5       ;TASTER FR FESTTEXT ABFRAGEN
                    GOTO    ENTPRELL
                    GOTO    ANFANG

ENTPRELL            MOVLW   D'100'
                    MOVWF   ZAE1

WEITER              BTFSC   GPIO, GP5
                    GOTO    ABFRAGE
                    MOVLW   D'10'
                    CALL    ZSMUE
                    DECFSZ  ZAE1, F
                    GOTO    WEITER

                    MOVLW   D'150'          ;3,0SEC LANG DRCKEN
                    MOVWF   ZAE1

WEIT                MOVLW   D'1'
                    CALL    ZS20MSEC
                    BTFSC   GPIO, GP5       ;TASTER ABFRAGEN
                    GOTO    TXT1

                    DECFSZ  ZAE1, F
                    GOTO    WEIT

;-------------
;DAS "S" FR SPEICHERN MORSEN
                    CALL    PUNKT                   
                    CALL    PUNKT
                    CALL    PUNKT
;                    CALL    DELAY
;                    CALL    DELAY
;                    CALL    PUNKT
;                    CALL    STRICH
;                    CALL    STRICH
;                    CALL    PUNKT

                    CLRF    MERK2
                    CLRF    ADR_MERK
;-------------
;DEN TASTER MUSS MAN ERST LOSLASSEN MIT ENTPRELLUNG 40MSEC=200*200SEC
ABFRAGE1            BTFSS   GPIO, GP5
                    GOTO    ABFRAGE1

                    MOVLW   D'200'
                    MOVWF   ZAE1

WEITER1             BTFSS   GPIO, GP5
                    GOTO    ABFRAGE1
                    MOVLW   D'200'
                    CALL    ZSMUE
                    DECFSZ  ZAE1, F
                    GOTO    WEITER1

;-------------------
;SPEICHERN MITTELS PADDLE

;ERST BEIM ERSTEN PADDLE-DRUCK SPEICHERN
PAD                 BTFSS   GPIO, GP2       ;STRICH
                    GOTO    AA0
                    BTFSS   GPIO, GP3       ;PUNKT
                    GOTO    AA0
;SPEICHERN BEENDEN
;MITTELS TASTER GLEICH AM ANFANG
                    BTFSC   GPIO, GP5       ;MITTELS TASTER 
                    GOTO    PAD
                    GOTO    WEITER3

;---------

AA0                 CLRF    STRPKT
                    CLRF    ADR             ;EEPROMADRESSE 0X00
                    CLRF    SP_BYTE         ;ZU SPEICHERNDES BYTE MIT 0X00
                    CLRF    ZAEHLER

                    BSF     STRPKT, BIT6    ;SETZEN FR DAS PADDLE MORSEN
                    BCF     STRPKT, BIT4
                    BCF     STRPKT, BIT2    ;BERLAUFMERKER AUS

;STRICH
SP_BEGIN            BTFSC   MERK2, BIT0
                    GOTO    WEITER3

                    BTFSC   GPIO, GP2       ;STRICH GEDRCKT?
                    GOTO    AA2
                    CALL    STRICH          ;WENN JA STRICH MORSEN
                    BSF     SP_BYTE, BIT7   ;UND SPEICHERN
                    RRF     SP_BYTE, F
                    INCF    ZAEHLER, F
                    
                MOVLW   D'7'
                SUBWF   ZAEHLER, W
                BTFSS   STATUS, Z
                GOTO    AA2

                BSF     SP_BYTE, BIT7
                MOVF    SP_BYTE, W
                CALL    E_WRITE
                CLRF    SP_BYTE
                INCF    ADR, F

                MOVF    ZAEHLER, W
                CALL    E_WRITE
                CLRF    ZAEHLER
                INCF    ADR, F

;PUNKT
AA2                 BTFSC   GPIO, GP3       ;PUNKT GEDRCKT?
                    GOTO    AA3
                    CALL    PUNKT           ;WENN JA PUNKT MORSEN
                    BCF     SP_BYTE, BIT7   ;UND SPEICHERN
                    RRF     SP_BYTE, F
                    INCF    ZAEHLER, F
                    
                MOVLW   D'7'
                SUBWF   ZAEHLER, W
                BTFSS   STATUS, Z
                GOTO    AA3

                BSF     SP_BYTE, BIT7
                MOVF    SP_BYTE, W
                CALL    E_WRITE
                CLRF    SP_BYTE
                INCF    ADR, F

                MOVF    ZAEHLER, W
                CALL    E_WRITE
                CLRF    ZAEHLER
                INCF    ADR, F

;STRICH
AA3                 BTFSS   STRPKT, BIT7    ;WENN STRICH MERKER GESETZT
                    GOTO    AA4
                    CALL    STRICH          ;STRICH MORSEN
                    BSF     SP_BYTE, BIT7   ;UND SPEICHERN
                    RRF     SP_BYTE, F
                    INCF    ZAEHLER, F
                    
                MOVLW   D'7'
                SUBWF   ZAEHLER, W
                BTFSS   STATUS, Z
                GOTO    AA4

                BSF     SP_BYTE, BIT7
                MOVF    SP_BYTE, W
                CALL    E_WRITE
                CLRF    SP_BYTE
                INCF    ADR, F

                MOVF    ZAEHLER, W
                CALL    E_WRITE
                CLRF    ZAEHLER
                INCF    ADR, F

;PUNKT
AA4                 BTFSS   STRPKT, BIT0    ;WENN PUNKT MERKER GESETZT
                    GOTO    SP
                    CALL    PUNKT           ;PUNKT MORSEN
                    BCF     SP_BYTE, BIT7   ;UND SPEICHERN
                    RRF     SP_BYTE, F
                    INCF    ZAEHLER, F
                    
                MOVLW   D'7'
                SUBWF   ZAEHLER, W
                BTFSS   STATUS, Z
                GOTO    SP

                BSF     SP_BYTE, BIT7
                MOVF    SP_BYTE, W
                CALL    E_WRITE
                CLRF    SP_BYTE
                INCF    ADR, F

                MOVF    ZAEHLER, W
                CALL    E_WRITE
                CLRF    ZAEHLER
                INCF    ADR, F

SP              CALL    SP_PAUSE

;--------
;SPEICHERBERLAUF KEIN TON DANN OK MORSEN 
                    BTFSS   STRPKT, BIT2
                    GOTO    ABFRAGE2
                    MOVLW   D'10'
                    MOVWF   ZAEHLER
WEITER8             CALL    DELAY
                    DECFSZ  ZAEHLER, F
                    GOTO    WEITER8
                    GOTO    WEITER3
;--------
;TASTERABFRAGE
ABFRAGE2            BTFSC   MERK2, BIT0
                    GOTO    WEITER3
                    BTFSC   GPIO, GP5
                    GOTO    SP_BEGIN

;-------------
;DAS OK MORSEN UND ENDEBYTES ABSPEICHERN
WEITER3             CLRF    MERK2
                    
                MOVLW   0X00
                SUBWF   ADR_MERK, W
                BTFSC   STATUS, Z
                GOTO    WEITER11

                    MOVF    ADR_MERK, W
                    MOVWF   ADR
                    MOVLW   0XFF
                    CALL    E_WRITE
                    INCF    ADR, F
                    MOVLW   0XFF
                    CALL    E_WRITE

WEITER11            CALL    STRICH
                    CALL    STRICH
                    CALL    STRICH
                    CALL    DELAY       ;ZWISCHEN DEN ZEICHEN DIE PAUSE
                    CALL    DELAY
                    CALL    DELAY
                    CALL    STRICH
                    CALL    PUNKT
                    CALL    STRICH
                    GOTO    ANFANG


;-------------
;FESTTEXT MORSEN AUSGABE
TXT1                BCF     STRPKT, BIT6    ;PADDLE MORSEN AUSSCHALTEN
                    BCF     STRPKT, BIT5    ;BAKE-MORSEN AUSSCHALTEN
                    BSF     STRPKT, BIT4    ;TEXT MORSEN EINSCHALTEN

T1                  CLRF    ADR             ;EEPROMADRESSE AUF START SETZEN

AUSL                CALL    E_READ
                    MOVWF   CW

                    BTFSS   CW, BIT7
                    GOTO    PAUS

                    INCF    ADR, F
                    CALL    E_READ
                    MOVWF   ANZ

                    MOVLW   0XFF                ;ENDEERKENNUNG BEIM ERSTEN AUSLESEN
                    SUBWF   ANZ, W
                    BTFSC   STATUS, Z
                    GOTO    TENDE
                    GOTO    T0

PAUS                CALL    CW_PAUSE
                    INCF    ADR, F
                    GOTO    AUSL

;---
;MORSEN
T0                  MOVLW   D'7'
                    SUBWF   ANZ, W
                    BTFSC   STATUS, Z
                    GOTO    T2
                    
                    MOVF    ANZ, W
                    SUBLW   D'7'
                    MOVWF   TXT_ZAE
T5                  RRF     CW, F
                    DECFSZ  TXT_ZAE, F
                    GOTO    T5
                    
T2                  BTFSS   CW, BIT0
                    GOTO    T3
                    CALL    STRICH
                    BTFSS   STRPKT, BIT4
                    GOTO    PKT_WEG
                    RRF     CW, F
                    DECFSZ  ANZ, F
                    GOTO    T2
                    GOTO    TX1

T3                  CALL    PUNKT
                    BTFSS   STRPKT, BIT4
                    GOTO    PKT_WEG
                    RRF     CW, F
                    DECFSZ  ANZ, F
                    GOTO    T2

TX1                 INCF    ADR, F
                    GOTO    AUSL



;BAKEN-WIEDERHOLUNG UND 0XFF EINDEERKENNUNG
TENDE               MOVF    ADR, W
                    SUBLW   0X01
                    BTFSC   STATUS, Z
                    GOTO    ANFANG

                    BTFSS   STRPKT, BIT5
                    GOTO    PKT_WEG
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    GOTO    T1

;PUNKT AUSBLENDEN BEI ABBRUCH MIT ENTPRELLUNG
PKT_WEG             MOVLW   D'100'
                    MOVWF   ZAE1

PKT_W               BTFSS   GPIO, GP3
                    GOTO    PKT_WEG
                    MOVLW   D'10'
                    CALL    ZSMUE
                    DECFSZ  ZAE1, F
                    GOTO    PKT_W
                    GOTO    ANFANG

;*****************************************************************************
;*                              PAUSE BEIM FESTTEXT AUSGEBEN                 *
;*                              05.05.12                                     *
;*****************************************************************************
CW_PAUSE        BTFSC   STRPKT, BIT6
                GOTO    CII1
                BTFSC   STRPKT, BIT4
                GOTO    CII1
                RETURN

CII1            BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE

CIII            BTFSS  PIR1, ADIF
                GOTO   CIII

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    


;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        MOVLW   0XF4        ;+500DEZ  // ALSO==>(0X01F4)+AD
                        ADDWF   AD_L, F     
                        BTFSS   STATUS, C   
                        GOTO    CT221

                        INCF    AD_H, F
CT221                   INCF    AD_H, F

;SUBTRAKTION VON 0XFFFF
                        MOVF    AD_L, W     ;AD --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_L        ;W       --> AD_L

                        MOVF    AD_H, W     ;AD0WERT --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_H        ;W       --> AD_H


CD0Y            MOVLW   D'8'
                MOVWF   MERK

CD02            BCF     T1CON, TMR1ON   ;STOP DES TIMER1

                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

                BSF     T1CON, TMR1ON   ;START DES TIMER1


CD01            BTFSS   STRPKT, BIT6    ;FESTTEXT MODUS 1X GESTARTET
                GOTO    CD03

                BTFSS   GPIO, GP2       ;STRICH-MERKER
                BSF     STRPKT, BIT7

                BTFSS   GPIO, GP3       ;PUNKT-MERKER
                BSF     STRPKT, BIT0
                GOTO    CD0X

CD03            BTFSS   GPIO, GP2       ;STRICH-MERKER FR FESTTEXT ALLES WIEDERHOLEN
                BSF     STRPKT, BIT5

                BTFSC   GPIO, GP3       ;PUNKT-MERKER -ENDE DES FESTTEXT ALSO SOFORT ABBRUCH
                GOTO    CD0X
                BCF     STRPKT, BIT5
                BCF     STRPKT, BIT4
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                CALL    AUS
                RETURN

CD0X            BTFSS   PIR1, TMR1IF
                GOTO    CD01

                DECFSZ  MERK, F
                GOTO    CD02

                DECFSZ  CW, F
                GOTO    CD0Y

                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                RETURN


;*****************************************************************************
;*                              PAUSE ABSPEICHERN                            *
;*                              05.05.12                                     *
;*****************************************************************************
SP_PAUSE            CLRF    ZAEHLER1

                    BTFSS   GPIO, GP2       ;STRICH
                    RETURN
                    BTFSS   GPIO, GP3       ;PUNKT
                    RETURN
                    BTFSC   STRPKT, BIT7    ;STRICHMERKER   
                    RETURN
                    BTFSC   STRPKT, BIT0    ;PUNKTMERKER
                    RETURN

                    BTFSC   MERK2, BIT0
                    RETURN
                    BTFSC   GPIO, GP5       ;MITTELS TASTER 
                    GOTO    SP_P
                    BSF     MERK2, BIT0
                    RETURN

;-----
;BEI ZAEHLER GRER NULL NUR SPEICHERN
SP_P            MOVF    ZAEHLER, W ;SP_BYTE, W
                SUBLW   D'0'
                BTFSS   STATUS, Z
                GOTO    SA
                GOTO    SI  ;RETURN

SA              BSF     SP_BYTE, BIT7
                MOVF    SP_BYTE, W
                CALL    E_WRITE
                CLRF    SP_BYTE
                INCF    ADR, F

                MOVF    ZAEHLER, W
                CALL    E_WRITE
                CLRF    ZAEHLER
                INCF    ADR, F

;--------
;ENDEADRESSE MERKEN FR ENDEKENNUNG
                MOVF    ADR, W             ;incf
                MOVWF   ADR_MERK

;----------TIMER+AD INIT
SI              BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE

SIII            BTFSS  PIR1, ADIF
                GOTO   SIII

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    


;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        MOVLW   0XF4        ;+500DEZ  // ALSO==>(0X01F4)+AD
                        ADDWF   AD_L, F     
                        BTFSS   STATUS, C   
                        GOTO    ST221

                        INCF    AD_H, F
ST221                   INCF    AD_H, F

;SUBTRAKTION VON 0XFFFF
                        MOVF    AD_L, W     ;AD --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_L        ;W       --> AD_L

                        MOVF    AD_H, W     ;AD0WERT --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_H        ;W       --> AD_H


SIF             MOVLW   D'8'
                MOVWF   MERK

SD02            BCF     T1CON, TMR1ON   ;STOP DES TIMER1

                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

                BSF     T1CON, TMR1ON   ;START DES TIMER1

SD01            BTFSS   GPIO, GP2       ;STRICH
                GOTO    SD03
                BTFSS   GPIO, GP3       ;PUNKT
                GOTO    SD03

                    BTFSS   MERK2, BIT0
                    GOTO    SD05
                    BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                    RETURN

SD05                BTFSC   GPIO, GP5       ;MITTELS TASTER 
                    GOTO    SD04
                    BSF     MERK2, BIT0
                    BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                    RETURN

SD04            BTFSS   PIR1, TMR1IF
                GOTO    SD01

                DECFSZ  MERK, F
                GOTO    SD02

                INCF    ZAEHLER1, F
                    
                MOVLW   0X7F
                SUBWF   ZAEHLER1, W
                BTFSS   STATUS, Z
                GOTO    SIF

                BCF     ZAEHLER1, BIT7
                MOVF    ZAEHLER1, W
                CALL    E_WRITE
;                CLRF    ZAEHLER1
                INCF    ADR, F
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                RETURN

SD03            BCF     T1CON, TMR1ON   ;STOP DES TIMER1

;-----
;BEI ZAEHLER GRER NULL NUR SPEICHERN
SD06            MOVF    ZAEHLER1, W
                SUBLW   D'0'
                BTFSC   STATUS, Z
                RETURN

                BCF     ZAEHLER1, BIT7
                MOVF    ZAEHLER1, W
                CALL    E_WRITE
;                CLRF    ZAEHLER1
                INCF    ADR, F
                RETURN

;*****************************************************************************
;*                              DELAY ZEIT FUER TEMPO                        *
;*                              05.05.12                                     *
;*****************************************************************************
DELAY           BTFSC   STRPKT, BIT6
                GOTO    II1
                BTFSC   STRPKT, BIT4
                GOTO    II1
                RETURN

II1             BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                MOVLW   D'5'
                CALL    ZSMUE               ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    


;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        MOVLW   0XF4        ;+500DEZ  // ALSO==>(0X01F4)+AD
                        ADDWF   AD_L, F     
                        BTFSS   STATUS, C   
                        GOTO    T221

                        INCF    AD_H, F
T221                    INCF    AD_H, F

;SUBTRAKTION VON 0XFFFF
                        MOVF    AD_L, W     ;AD --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_L        ;W       --> AD_L

                        MOVF    AD_H, W     ;AD0WERT --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_H        ;W       --> AD_H


                MOVLW   D'16'
                MOVWF   MERK

D02             BCF     T1CON, TMR1ON   ;STOP DES TIMER1

                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

                BSF     T1CON, TMR1ON   ;START DES TIMER1


D01             BTFSS   STRPKT, BIT6    ;FESTTEXT MODUS 1X GESTARTET
                GOTO    D03

                BTFSS   GPIO, GP2       ;STRICH-MERKER
                BSF     STRPKT, BIT7

                BTFSS   GPIO, GP3       ;PUNKT-MERKER
                BSF     STRPKT, BIT0
                GOTO    D0X

D03             BTFSS   GPIO, GP2       ;STRICH-MERKER FR FESTTEXT ALLES WIEDERHOLEN
                BSF     STRPKT, BIT5

                BTFSC   GPIO, GP3       ;PUNKT-MERKER -ENDE DES FESTTEXT ALSO SOFORT ABBRUCH
                GOTO    D0X
                BCF     STRPKT, BIT5
                BCF     STRPKT, BIT4
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                CALL    AUS
                RETURN

D0X             BTFSS   PIR1, TMR1IF
                GOTO    D01

                DECFSZ  MERK, F
                GOTO    D02
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                RETURN


;*****************************************************************************
;*                          BERECHNUNG FUER TEMPO                             *
;*****************************************************************************
;VORRAUSETZUNG 54MSEC==90ZPM FUER EINE EINHEIT VON DELAY

;MIT PROPORTION ZU 60ZPM ERGEBEN SICH 81MSEC FR EINE EIHEIT VON DELAY

;ES WIRD TIMER 1 GENOMMEN, DA ER AUCH BEI DER AD-WANDLUNG MIT DER TEMPOEINSTELLUNG
;VERWENDET WERDEN SOLL

;TIMER 1 WIRD 32MAL DURCHLAUFEN
;81MSEC : 32 = 2,531MSEC MUSS TIMER 1 BEI TMR1L + TMR1H EINGESTELLT SEIN

;TEILER 1:4(PRESCALER) UND OSZI 1:4 ==>1:16
;16*0.25S=4S

;2,531MSEC : 4SEC = 632 MAL ==278HEX
;0XFFFF - 0X0278 = 0XFD87

;ALSO
;TMR1L=0X87
;TMR1H=0XFD

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;HOEHERES TEMPO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;SCHON FUER AD-WANDLUNG ALSO TEMPO-EINSTELLUNG VORBEREITETER TEXT
;50-150ZPM
;97MS-32MS
;6MS-2MS  /16 NORMALE DURCHGANGSANZAHL FUER EINE EINHEIT ALSO DELAY
;
;TEILER 1:4(PRESCALER) UND OSZI 1:4 ==>1:16
;
;16*0.25S=4S
;      500*4S=2MS*16=32MS ==> 150ZPM
;(1023+500)*4S=6,092MS*16=97MS ==> 50ZPM
;ALSO GRUNDWERT 500 ZUM NORMALEN AD-WERT ADDIEREN UND VON 0XFFFF ABZIEHEN
;
;BEI SP_PAUSE AUF 8 AUCH EINGESTELLT !!!!!!!!!!!!!!!!!!!!!
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------



;*****************************************************************************
;*                              STRICH                                       *
;*                              4.12.12                                      *
;*****************************************************************************
STRICH          BTFSC   STRPKT, BIT6
                GOTO    III1
                BTFSC   STRPKT, BIT4
                GOTO    III1
                RETURN

III1        CALL    EIN
            CALL    DELAY
            CALL    DELAY
            CALL    DELAY
            CALL    AUS
            CALL    DELAY
            BCF     STRPKT, BIT7    ;STRICHMERKER AUS
            RETURN

;*****************************************************************************
;*                              PUNKT                                        *
;*                              4.12.12                                      *
;*****************************************************************************
PUNKT           BTFSC   STRPKT, BIT6
                GOTO    III2
                BTFSC   STRPKT, BIT4
                GOTO    III2
                RETURN

III2        CALL    EIN
            CALL    DELAY
            CALL    AUS
            CALL    DELAY
            BCF     STRPKT, BIT0    ;PUNKT MERKER AUS
            RETURN

;*****************************************************************************
;*                              X*10S ZEITSCHLEIFE                          *
;*                              31.10.03                                     *
;*****************************************************************************

ZSMUE       MOVWF   ZAE
MSA1        NOP             ;10X NOP ALSO T=40*0.25S=10S  *5=50S  +T16(4S)
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ  ZAE, F
            GOTO    MSA1
            RETURN

;*****************************************************************************
;*                              CW-EIN                                       *
;*                              04.05.12                                     *
;*****************************************************************************
EIN
    BSF     GPIO, GP0
    BSF     GPIO, GP1
    RETURN

;*****************************************************************************
;*                              CW-AUS                                       *
;*                              04.05.12                                     *
;*****************************************************************************
AUS
    BCF     GPIO, GP0
    BCF     GPIO, GP1
    RETURN

;*****************************************************************************
;*                              ZEITSCHLEIFE                                 *
;*                              05.05.12                                     *
;*****************************************************************************
ZS20MSEC                MOVWF   MERK1

T031                    MOVLW   D'2'                    ;ES WERDEN JETZT 20MSEC=0,02SEC ABGEARBEITET INNERE SCHLEIFE
                        MOVWF   MERK                    ;DER INHALT VON W WIRD IN "MERK" GELADEN

T011                    MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T021                    BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T021                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  MERK, F                 ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T011                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        DECFSZ  MERK1, F                ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T031                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 10MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;10MS : 256S= 39                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'39'=10MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;217 DEZIMAL OBEN EINTRAGEN


;*****************************************************************************
;*                              EEPROM WRITE                                 *
;*                              17.12.08                                     *
;*****************************************************************************
;DIE EEPROMADRESSE MUSS IN ADR STEHEN
;DAS ZU SPEICHERNDE BYTE IN W STEHEN

E_WRITE         BCF     PIR1, EEIF
                BANK1
                MOVWF   EEDAT
                BANK0

                MOVLW   0X7A            ;SPEICHERBERLAUF AB 0X7A
                SUBWF   ADR, W
                BTFSS   STATUS, C
                GOTO    W_2
                ;DECF    ADR, F
                BSF     STRPKT, BIT2    ;MERKER AUF EIN
                RETURN

W_2             MOVF    ADR, W
                BANK1
                MOVWF   EEADR

                BSF     EECON1, WREN
                MOVLW   0X55
                MOVWF   EECON2
                MOVLW   0XAA
                MOVWF   EECON2
                BSF     EECON1, WR
W_1             BTFSC   EECON1, WR
                GOTO    W_1
                BCF     EECON1, WREN
                BANK0
                BCF     PIR1, EEIF
                RETURN

;*****************************************************************************
;*                              EEPROM READ                                  *
;*                              16.12.08                                     *
;*****************************************************************************
;DAS ERGEBNIS DES WERTES VOM EEPROM-INHALT STEHT AM ENDE IN W

E_READ          MOVF    ADR, W
                BANK1
                MOVWF   EEADR
                BSF     EECON1, RD
EE1             BTFSC   EECON1, RD
                GOTO    EE1
                MOVF    EEDAT, W
                BANK0
                RETURN




    END

