;*****************************************************************************
;*                            EINFACHER KEYER                                *
;*                              04.12.12                                     *
;*---------------------------------------------------------------------------*
;*                           BEGINN: 01.11.13                                *
;*                           ENDE  : XX.11.13                                *
;*                         GETESTET: XX.11.13                                *
;*****************************************************************************

        LIST    P=12F683       
        TITLE   "KEYER"

        ERRORLEVEL -302
        INCLUDE <P12F683.INC>

__CONFIG _INTRC_OSC_NOCLKOUT &_INTOSCIO & _IESO_OFF & _FCMEN_OFF &_WDT_OFF & _PWRTE_OFF & _BOD_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU     0X22               
MERK1                   EQU     0X23
CW_ZAE                  EQU     0X24             
TXT_ZAE                 EQU     0X25
TXT_MERK                EQU     0X26
COD                     EQU     0X27
ANZ                     EQU     0X28
STRPKT                  EQU     0X29

;FR STRPKT GILT:
;BIT7 STRICH MERKER BEI NORMALEM PADDEL-BETRIEB
;BIT0 PUNKT MERKER BEI NORMALEM PADDEL-BETRIEB
;--
;BIT4 MERKER FR FESTTEXT-MORSEN GLEICH NACH DEM START
;BIT5 MERKER WENN STRICH GEDRCKT IST GEHT ES ZUM BAKEN MORSEN BER
;BIT6 BEI 1 IST ES PADDLE MORSEN / BEI 0 IST ES FESTTEXTMORSEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AD_L                    EQU     0X2A
AD_H                    EQU     0X2B
ZAE                     EQU     0X2C
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------

;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

GP0         EQU 0
GP1         EQU 1 
GP2         EQU 2 
GP3         EQU 3 
GP4         EQU 4
GP5         EQU 5 


;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ; SOFORT INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON0

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'00111000'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP0 + GP1 DIGITAL I/O     AN3 -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11111100'                 ;GP0 + GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;OSCILLATOR AUF 4MHZ INTERN EINSTELLEN
                        MOVLW   B'01100101'
                        MOVWF   OSCCON

;INIT TIMER 0 FUER 10MSEC FUER ZEITSCHLEIFE 
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)
                        MOVLW   B'10000111'                 ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0


;INIT TIMER 1 
                        MOVLW   B'00100000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [10]1:4 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10001100' ;ADMF=1 RECHTSBNDIG, VDD ALS REF, CHANNEL AN3, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;DIE LED SOLL AM ANFANG AUS SEIN              
                        CLRF   GPIO
;---------------INITIALISIERUNG--ZU--ENDE-----------------------


                    MOVLW   D'20'           ;ZEITSCHLEIFE FUER 2SEC EINGESTELLT
                    CALL    DAUER           ;UM EINSCHALTIMPULS ZU UNTERDRUECKEN

                    CLRF    STRPKT

ANFANG              BSF     STRPKT, BIT6    ;SETZEN FR DAS PADDLE MORSEN

                    BTFSS   GPIO, GP2       ;STRICH GEDRCKT?
                    CALL    STRICH          ;WENN JA STRICH MORSEN

                    BTFSS   GPIO, GP3       ;PUNKT GEDRCKT?
                    CALL    PUNKT           ;WENN JA PUNKT MORSEN

                    BTFSC   STRPKT, BIT7    ;WENN STRICH MERKER GESETZT
                    CALL    STRICH          ;STRICH MORSEN

                    BTFSC   STRPKT, BIT0    ;WENN PUNKT MERKER GESETZT
                    CALL    PUNKT           ;PUNKT MORSEN

;                    GOTO    ANFANG

ANFANG0             BTFSC   STRPKT, BIT5
                    GOTO    ANF
                    BTFSS   GPIO, GP5       ;TASTER FR FESTTEXT ABFRAGEN
                    GOTO    ANF0
                    BCF     STRPKT, BIT4
                    GOTO    ANFANG

ANF0                BSF     STRPKT, BIT4    ;FESTTEXT GESTARTET MERKER
                    BCF     STRPKT, BIT6    ;PADDLE MORSEN AUSSCHALTEN

ANF                 CLRF    TXT_ZAE
ANF1                CALL    MTXT
                    MOVWF   TXT_MERK
                    MOVLW   H'00'           ;ADRESSE SPEICHERN NEUES PCLATH
                    MOVWF   PCLATH
;
                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT_MERK, W
                    BTFSS   STATUS, Z
                    GOTO    WEITER

                    BTFSC   STRPKT, BIT5
                    GOTO    ANFANG0
UNTERDR         BTFSS   GPIO, GP3            ;PUNKT UNTERDRUECKEN, DAMIT ES NICHT GLEICH EINEN PUNKT MORST BEI ABBRUCH
                GOTO    UNTERDR
;                    MOVLW   D'5'            ;ZEITSCHLEIFE FUER 0,5SEC EINGESTELLT
;                    CALL    DAUER
                    GOTO    ANFANG0


WEITER              MOVLW   ' '             ;ZWISCHEN WRTERN DIE PAUSE
                    SUBWF   TXT_MERK, W
                    BTFSS   STATUS, Z
                    GOTO    A03
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    CALL    DELAY
                    GOTO    RR2         ;ODER BESSER ZU RR1 MIT 3X DELAY

A03                 CLRF    CW_ZAE
A01                 CALL    MZEI
                    MOVWF   MERK
                    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH
                    MOVWF   PCLATH      ;

                    MOVF    MERK, W
                    SUBWF   TXT_MERK, W
                    BTFSC   STATUS, Z
                    GOTO    A02
                    INCF    CW_ZAE, F
                    GOTO    A01

A02                 CALL    MANZ
                    MOVWF   ANZ
                    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH
                    MOVWF   PCLATH      ;

                    CALL    MCOD
                    MOVWF   COD
                    MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH
                    MOVWF   PCLATH      ;

;----

ZEICHEN             MOVLW   0X80                    ;ZWISCHENSPEICHERN VON MASKE PUNKT/STRICH
                    MOVWF   MERK

                    MOVF    COD, W                  ;DAS FOLGE-ZEICHEN
                    ANDWF   MERK, F
                    BTFSS   MERK, BIT7              ;ALSO 001100 IST ..--.. 
                    GOTO    PUNKT1

STRICH1             CALL    STRICH
                    GOTO    RR

PUNKT1              CALL    PUNKT

RR                  RLF     COD, F      ;
                    DECFSZ  ANZ,F       ;ZEICHENANZAHL DECRIMENTIEREN, 
                    GOTO    ZEICHEN

RR1                 CALL    DELAY       ;ZWISCHEN DEN ZEICHEN DIE PAUSE
                    CALL    DELAY
                    CALL    DELAY
RR2                 INCF    TXT_ZAE, F
                    GOTO    ANF1


;*****************************************************************************
;*                              DELAY ZEIT FUER TEMPO                        *
;*                              05.05.12                                     *
;*****************************************************************************
DELAY           BTFSC   STRPKT, BIT6
                GOTO    II1
                BTFSC   STRPKT, BIT4
                GOTO    II1
                BTFSC   STRPKT, BIT5
                GOTO    II1
                RETURN

II1             BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    MUE50               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    MUE50               ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    


;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L

;BERECHNUNG
                        MOVLW   0XF4        ;+500DEZ  // ALSO==>(0X01F4)+AD
                        ADDWF   AD_L, F     
                        BTFSS   STATUS, C   
                        GOTO    T221

                        INCF    AD_H, F
T221                    INCF    AD_H, F

;SUBTRAKTION VON 0XFFFF
                        MOVF    AD_L, W     ;AD --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_L        ;W       --> AD_L

                        MOVF    AD_H, W     ;AD0WERT --> W
                        SUBLW   0XFF        ;0XFF-W  --> W
                        MOVWF   AD_H        ;W       --> AD_H


                MOVLW   D'16'
                MOVWF   MERK

D02             BCF     T1CON, TMR1ON   ;STOP DES TIMER1

                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

                BSF     T1CON, TMR1ON   ;START DES TIMER1


D01             BTFSC   STRPKT, BIT4    ;FESTTEXT MODUS 1X GESTARTET
                GOTO    D03

                BTFSS   GPIO, GP2       ;STRICH-MERKER
                BSF     STRPKT, BIT7

                BTFSS   GPIO, GP3       ;PUNKT-MERKER
                BSF     STRPKT, BIT0
                GOTO    D0X

D03             BTFSS   GPIO, GP2       ;STRICH-MERKER FR FESTTEXT ALLES WIEDERHOLEN
                BSF     STRPKT, BIT5

                BTFSC   GPIO, GP3       ;PUNKT-MERKER -ENDE DES FESTTEXT ALSO SOFORT ABBRUCH
                GOTO    D0X
                BCF     STRPKT, BIT5
                BCF     STRPKT, BIT4
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                CALL    AUS
                RETURN

D0X             BTFSS   PIR1, TMR1IF
                GOTO    D01

                DECFSZ  MERK, F
                GOTO    D02
                RETURN


;*****************************************************************************
;*                          BERECHNUNG FUER TEMPO                             *
;*****************************************************************************
;VORRAUSETZUNG 54MSEC==90ZPM FUER EINE EINHEIT VON DELAY

;MIT PROPORTION ZU 60ZPM ERGEBEN SICH 81MSEC FR EINE EIHEIT VON DELAY

;ES WIRD TIMER 1 GENOMMEN, DA ER AUCH BEI DER AD-WANDLUNG MIT DER TEMPOEINSTELLUNG
;VERWENDET WERDEN SOLL

;TIMER 1 WIRD 32MAL DURCHLAUFEN
;81MSEC : 32 = 2,531MSEC MUSS TIMER 1 BEI TMR1L + TMR1H EINGESTELLT SEIN

;TEILER 1:4(PRESCALER) UND OSZI 1:4 ==>1:16
;16*0.25S=4S

;2,531MSEC : 4SEC = 632 MAL ==278HEX
;0XFFFF - 0X0278 = 0XFD87

;ALSO
;TMR1L=0X87
;TMR1H=0XFD

;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;HOEHERES TEMPO !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;SCHON FUER AD-WANDLUNG ALSO TEMPO-EINSTELLUNG VORBEREITETER TEXT
;50-150ZPM
;97MS-32MS
;6MS-2MS  /16 NORMALE DURCHGANGSANZAHL FUER EINE EINHEIT ALSO DELAY
;
;TEILER 1:4(PRESCALER) UND OSZI 1:4 ==>1:16
;
;16*0.25S=4S
;      500*4S=2MS*16=32MS ==> 150ZPM
;(1023+500)*4S=6,092MS*16=97MS ==> 50ZPM
;ALSO GRUNDWERT 500 ZUM NORMALEN AD-WERT ADDIEREN UND VON 0XFFFF ABZIEHEN
;
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------


;*****************************************************************************
;*                              STRICH                                       *
;*                              4.12.12                                      *
;*****************************************************************************
STRICH          BTFSC   STRPKT, BIT6
                GOTO    STR
                BTFSC   STRPKT, BIT4
                GOTO    STR
                BTFSC   STRPKT, BIT5
                GOTO    STR
                RETURN


STR         CALL    EIN
            CALL    DELAY
            CALL    DELAY
            CALL    DELAY
            CALL    AUS
            CALL    DELAY
            BCF     STRPKT, BIT7    ;STRICHMERKER AUS
            RETURN

;*****************************************************************************
;*                              PUNKT                                        *
;*                              4.12.12                                      *
;*****************************************************************************
PUNKT           BTFSC   STRPKT, BIT6
                GOTO    PKT
                BTFSC   STRPKT, BIT4
                GOTO    PKT
                BTFSC   STRPKT, BIT5
                GOTO    PKT
                RETURN

PKT         CALL    EIN
            CALL    DELAY
            CALL    AUS
            CALL    DELAY
            BCF     STRPKT, BIT0    ;PUNKT MERKER AUS
            RETURN

;*****************************************************************************
;*                              50S ZEITSCHLEIFE                            *
;*                              31.10.03                                     *
;*****************************************************************************

MUE50       MOVLW   D'5'
            MOVWF   ZAE
MSA1        NOP             ;10X NOP ALSO T=40*0.25S=10S  *5=50S  +T16(4S)
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ  ZAE, F
            GOTO    MSA1
            RETURN

;*****************************************************************************
;*                              CW-EIN                                       *
;*                              04.05.12                                     *
;*****************************************************************************
EIN
    BSF     GPIO, GP0
    BSF     GPIO, GP1
    RETURN

;*****************************************************************************
;*                              CW-AUS                                       *
;*                              04.05.12                                     *
;*****************************************************************************
AUS
    BCF     GPIO, GP0
    BCF     GPIO, GP1
    RETURN

;*****************************************************************************
;*                              ZEITSCHLEIFE                                 *
;*                              05.05.12                                     *
;*****************************************************************************
DAUER                   MOVWF   MERK1

T03                     MOVLW   D'10'                   ;ES WERDEN JETZT 100MSEC=0,1SEC ABGEARBEITET INNERE SCHLEIFE
                        MOVWF   MERK                    ;DER INHALT VON W WIRD IN "MERK" GELADEN

T01                     MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02                     BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T02                     ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  MERK, F                 ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T01                     ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        DECFSZ  MERK1, F                ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T03                     ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 10MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;10MS : 256S= 39                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'39'=10MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;217 DEZIMAL OBEN EINTRAGEN



                        ORG 0X0250
;*****************************************************************************
;*                       MORSE-PUNKT-STRICH-CODE                             *
;*                              20.12.98                                     *
;*****************************************************************************
MCOD
    MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    CW_ZAE,W    ; ZAEHLER DER LAENGE
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------

    RETLW B'01000000'   ;A 2 DIE ZAHL IST DIE ANZAHL ///DIE 0 = PUNKT DIE 1=STRICH
    RETLW B'10000000'   ;B 4
    RETLW B'10100000'   ;C 4
    RETLW B'10000000'   ;D 3
    RETLW B'00000000'   ;E 1
    RETLW B'00100000'   ;F 4
    RETLW B'11000000'   ;G 3
    RETLW B'00000000'   ;H 4
    RETLW B'00000000'   ;I 2
    RETLW B'01110000'   ;J 4
    RETLW B'10100000'   ;K 3
    RETLW B'01000000'   ;L 4
    RETLW B'11000000'   ;M 2
    RETLW B'10000000'   ;N 2
    RETLW B'11100000'   ;O 3
    RETLW B'01100000'   ;P 4
    RETLW B'11010000'   ;Q 4
    RETLW B'01000000'   ;R 3
    RETLW B'00000000'   ;S 3
    RETLW B'10000000'   ;T 1
    RETLW B'00100000'   ;U 3
    RETLW B'00010000'   ;V 4
    RETLW B'01100000'   ;W 3
    RETLW B'10010000'   ;X 4
    RETLW B'10110000'   ;Y 4
    RETLW B'11000000'   ;Z 4
    RETLW B'11111000'   ;0 5
    RETLW B'01111000'   ;1 5
    RETLW B'00111000'   ;2 5
    RETLW B'00011000'   ;3 5
    RETLW B'00001000'   ;4 5
    RETLW B'00000000'   ;5 5
    RETLW B'10000000'   ;6 5
    RETLW B'11000000'   ;7 5
    RETLW B'11100000'   ;8 5
    RETLW B'11110000'   ;9 5
    RETLW B'00110000'   ;? 6
    RETLW B'11001100'   ;, 6
    RETLW B'10010000'   ;/ 5
    RETLW B'01010100'   ;. 6
    RETLW B'10001000'   ;= 5
    RETLW 0XFF

;*****************************************************************************
;*                       MORSE-PUNKT-STRICH-ANZAHL                           *
;*                              20.12.98                                     *
;*****************************************************************************
MANZ
    MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    CW_ZAE,W    ; ZAEHLER DER LAENGE
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT ANZAHL DER STRICHE/PUNKTE FR ALLE DEUTSCHEN MORSEZEICHEN

    RETLW D'2'  ;A 2  0 BYTEAUSWAHLKONTROLLE   DIE ZAHL IST DIE ANZAHL
    RETLW D'4'  ;B 4  1
    RETLW D'4'  ;C 4  2
    RETLW D'3'  ;D 3  3
    RETLW D'1'  ;E 1  4
    RETLW D'4'  ;F 4  5
    RETLW D'3'  ;G 3  6
    RETLW D'4'  ;H 4  7
    RETLW D'2'  ;I 2  8
    RETLW D'4'  ;J 4  9 
    RETLW D'3'  ;K 3  10
    RETLW D'4'  ;L 4  11
    RETLW D'2'  ;M 2  12
    RETLW D'2'  ;N 2  13
    RETLW D'3'  ;O 3  14
    RETLW D'4'  ;P 4  15
    RETLW D'4'  ;Q 4  16
    RETLW D'3'  ;R 3  17
    RETLW D'3'  ;S 3  18
    RETLW D'1'  ;T 1  19
    RETLW D'3'  ;U 3  20
    RETLW D'4'  ;V 4  21
    RETLW D'3'  ;W 3  22
    RETLW D'4'  ;X 4  23
    RETLW D'4'  ;Y 4  24
    RETLW D'4'  ;Z 4  25
    RETLW D'5'  ;0 5  26
    RETLW D'5'  ;1 5  27
    RETLW D'5'  ;2 5  28
    RETLW D'5'  ;3 5  29
    RETLW D'5'  ;4 5  30
    RETLW D'5'  ;5 5  31
    RETLW D'5'  ;6 5  32
    RETLW D'5'  ;7 5  33
    RETLW D'5'  ;8 5  34 
    RETLW D'5'  ;9 5  35
    RETLW D'6'  ;? 6  36
    RETLW D'6'  ;, 6  37
    RETLW D'5'  ;/ 5  38
    RETLW D'6'  ;. 6  39
    RETLW D'5'  ;= 5  40   
    RETLW 0XFF

;*****************************************************************************
;*                           ZEICHENTABELLE                                  *
;*                              20.12.98                                     *
;*****************************************************************************
MZEI
    MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    CW_ZAE,W    ; ZAEHLER DER LAENGE
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMEN DIE ZEICHEN WELCHE VERGLICHEN WERDEN MUESSEN

    RETLW 'A'   ;A 2  0 BYTEAUSWAHLKONTROLLE   DIE ZAHL IST DIE ANZAHL
    RETLW 'B'   ;B 4  1
    RETLW 'C'   ;C 4  2
    RETLW 'D'   ;D 3  3
    RETLW 'E'   ;E 1  4
    RETLW 'F'   ;F 4  5
    RETLW 'G'   ;G 3  6
    RETLW 'H'   ;H 4  7
    RETLW 'I'   ;I 2  8
    RETLW 'J'   ;J 4  9 
    RETLW 'K'   ;K 3  10
    RETLW 'L'   ;L 4  11
    RETLW 'M'   ;M 2  12
    RETLW 'N'   ;N 2  13
    RETLW 'O'   ;O 3  14
    RETLW 'P'   ;P 4  15
    RETLW 'Q'   ;Q 4  16
    RETLW 'R'   ;R 3  17
    RETLW 'S'   ;S 3  18
    RETLW 'T'   ;T 1  19
    RETLW 'U'   ;U 3  20
    RETLW 'V'   ;V 4  21
    RETLW 'W'   ;W 3  22
    RETLW 'X'   ;X 4  23
    RETLW 'Y'   ;Y 4  24
    RETLW 'Z'   ;Z 4  25
    RETLW '0'   ;0 5  26
    RETLW '1'   ;1 5  27
    RETLW '2'   ;2 5  28
    RETLW '3'   ;3 5  29
    RETLW '4'   ;4 5  30
    RETLW '5'   ;5 5  31
    RETLW '6'   ;6 5  32
    RETLW '7'   ;7 5  33
    RETLW '8'   ;8 5  34 
    RETLW '9'   ;9 5  35
    RETLW '?'   ;? 6  36
    RETLW ','   ;, 6  37
    RETLW '/'   ;/ 5  38
    RETLW '.'   ;. 6  39
    RETLW '='   ;= 5  40    
    RETLW 0XFF
    
    ORG 0X0300
;*****************************************************************************
;*                       MORSE-BAKEN-TEXT ZEILENWEISE                        *
;*                              04.05.12                                     *
;*****************************************************************************
MTXT
    MOVLW   H'03'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    TXT_ZAE,W   ; ZAEHLER DER LAENGE
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  ??

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER MORSE-TEXT
;ALLE BUCHSTABEN IN GROSSSCHREIBWEISE
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN
;ES KOENNEN CA. 240 ZEILEN MIT RETLW EINGETRAGEN WERDEN /// ALSO BIS SPEICHERENDE 0X3FF /// KONTROLLIERE LIST-FILE

    RETLW "C"
    RETLW "Q"
    RETLW " "
    RETLW "C"
    RETLW "Q"
    RETLW " "
    RETLW "D"
    RETLW "E"
    RETLW " "
    RETLW "D"
    RETLW "L"
    RETLW "3"
    RETLW "U"
    RETLW "K"
    RETLW "H"
    RETLW " "
    RETLW "D"
    RETLW "L"
    RETLW "3"
    RETLW "U"
    RETLW "K"
    RETLW "H"
    RETLW " "       ;MUSS DRIN SEIN, WENN DAUERMORSEN GEMACHT WIRD, MUSS EINE PAUSE ZWISCHEN ANFANG RETLW "C" UND ENDE RETLW "H" SEIN

    RETLW 0XFF      ;ENDEKENNZEICHEN MUSS DRIN SEIN


    END

